#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <vga.h>
#include "libvga.h"
/*
#define NOVIDEO
*/
#define VGA_START_COMMAND 0x00ff5754
#define NOERRORS
int *input_space, *output_space;

int svga_setpalvec(void)
{
	*output_space = vga_setpalvec(*input_space, *(input_space + 1),
		input_space + 2);
	return 4;
}

int svga_getpalvec(void)
{
	*output_space = vga_getpalvec(* input_space, *(input_space + 1), 
			output_space + 1);
	return *(input_space + 1) * 4 + 4;
}

int svga_getpalette(void)
{
	*output_space = vga_getpalette(*input_space, output_space + 1, 
			output_space + 2, output_space + 3);
	return 16;
}

int svga_init(void){
	int r;
	char arr[200];

	output_space[0] = vga_init();
	output_space[1] = __svgalib_banked_mem_base;
	output_space[2] = __svgalib_banked_mem_size;
	output_space[3] = __svgalib_linear_mem_base;
	output_space[4] = __svgalib_linear_mem_size;
	
	return 20;
}
	
	
struct request_t {
	int bytes_out;
	
	/*1 if the function take ints or void for input and output */
	int normal;
	
	void *function;
	int bytes_in;
} handlers[48] = {
#include "serverpart.c"
	{20, 0, & svga_init, 0},		/*0*/
	{16, 0, &svga_getpalette, 4},
	{4, 0, &svga_setpalvec, 1032},
	{1028, 0, &svga_getpalvec, 8},
};
			
int request_size[1] = {4};
 
int main(int argc, char **argv)
{
	unsigned int request;
	char r[40] = "first server message\n";
	unsigned char zero = 0;
	
	input_space = malloc(1032);
	output_space = malloc(1032);
	write(1, r, 21);
	for(;;){
		read(0, &request, 4);
		if(request != VGA_START_COMMAND){
			fprintf(stderr, "No start token!\n");
			exit(1);
		}
		read(0, &request, 4);
#if !defined(NOERRORS)
		fprintf(stderr, "Read %d\n", request);
#endif
		if(request > sizeof(handlers) / sizeof(struct request_t)) {
			fprintf(stderr, "Error! %c %c %c %c\n", 
				request >> 24,(request >> 16) & 0xff, 
				(request >> 8) & 0xff, request & 0xff);
			exit(1);
		}
		read(0, input_space, handlers[request] . bytes_in);
		if(handlers[request] . normal){
#if !defined(NOVIDEO)
			switch(handlers[request] . bytes_out){
			case 0:	switch(handlers[request] . bytes_in){
				case 0: (*(void (*)(void))handlers[
					request] . function)();
					break;
				case 4: (*(void(*)(int))handlers[request] .
						function)(*(input_space));
					break;

				default:	fprintf(stderr, "Error 1.\n");
					exit(1);
				}
				break;
			case 4:	switch(handlers[request] . bytes_in){
				case 0: * output_space = 
						(*(int(*)(void))
						handlers[request] .
						function)();
					break;
				case 4: * output_space = 
						(*(int(*)(int))
						handlers[request] .
						function)(*input_space);
					break;
				case 16:*output_space = (*(int(*)(int, int, 
						int, int)) handlers[request].
						function)(*input_space,
						*(input_space + 1),
						*(input_space + 2),
						*(input_space + 3));
					break;
				default:	fprintf(stderr, "Error 2.\n");
					exit(1);
				}
				break;
			default: 	fprintf(stderr, "Error 3.\n");
				exit(1);
			}
#endif
			write(1, &zero, 1);
			write(1, output_space, handlers[request] . bytes_out);
		} else if(handlers[request] . function) {
#if !defined(NOVIDEO)
			request = (*(int (*)(void)) handlers[request] .
				function)();
			write(1, &zero, 1);
			write(1, output_space, request);
#else
			fprintf(stderr, "fatal error\n");
			exit(1);
#endif
		}
	}
}
